/*
 * readwrite.cpp
 *
 * Copyright (c) & Programmed 2010 by NAKATA H.
 */

#ifndef	_MSC_VER
#include <stdio.h>

#include <sys/types.h>
#endif	// __MSC_VER

#ifndef TRUE
#define TRUE (-1)
#define FALSE 0
#endif

int myread(int, void * ,int );

/* read 32bit Little Endian data from file	-----------------------------*/
int read32bitint(int fd, u_int32_t *p_int32)
{
  unsigned char buff[4];

  if ( myread(fd, buff, 4) != 4 ) {
    fprintf(stderr, "myread() failed.\n" );
    return (FALSE);
  }

  *p_int32 = (buff[0] | (((int)buff[1]) << 8)
	      | (((int)buff[2]) << 16) | (((int)buff[3]) << 24));
  return (TRUE);
}

/* read 64bit Little Endian data from file	-----------------------------*/
int read64bitlong(int fd, u_int64_t *p_int64)
{
  unsigned char buff[8];

  if ( myread(fd, buff, 8) != 8 ) {
    fprintf(stderr, "myread() failed.\n" );
    return (FALSE);
  }

  *p_int64 = (buff[0] | (((int64_t)buff[1]) << 8)
	      | (((int64_t)buff[2]) << 16) | (((int64_t)buff[3]) << 24)
	      | (((int64_t)buff[4]) << 32) | (((int64_t)buff[5]) << 40)
	      | (((int64_t)buff[6]) << 48) | (((int64_t)buff[7]) << 56));
  return (TRUE);
}

/* read 16bit Big Endian data from file	-----------------------------*/
int read16bitBEint(int fd, u_int16_t *p_int16)
{
  unsigned char buff[2];

  if ( myread(fd, buff, 2) != 2 ) {
    fprintf(stderr, "myread() failed.\n" );
    return (FALSE);
  }

  *p_int16 = (buff[1] | ((int)buff[0]) << 8);
  return (TRUE);
}

/* read 32bit Big Endian data from file	-----------------------------*/
int read32bitBEint(int fd, u_int32_t *p_int32)
{
  unsigned char buff[4];

  if ( myread(fd, buff, 4) != 4 ) {
    fprintf(stderr, "myread() failed.\n" );
    return (FALSE);
  }

  *p_int32 = (buff[3] | (((int)buff[2]) << 8)
	      | (((int)buff[1]) << 16) | (((int)buff[0]) << 24));
  return (TRUE);
}

/* read 64bit Big Endian data from file	-----------------------------*/
int read64bitBElong(int fd, u_int64_t *p_int64)
{
  unsigned char buff[8];

  if ( myread(fd, buff, 8) != 8 ) {
    fprintf(stderr, "myread() failed.\n" );
    return (FALSE);
  }

  *p_int64 = (buff[7] | (((int64_t)buff[6]) << 8)
	      | (((int64_t)buff[5]) << 16) | (((int64_t)buff[4]) << 24)
	      | (((int64_t)buff[3]) << 32) | (((int64_t)buff[2]) << 40)
	      | (((int64_t)buff[1]) << 48) | (((int64_t)buff[0]) << 56));
  return (TRUE);
}

/* read 32bit float to file	-----------------------------*/
int readfloat(int fd, float *p_data)
{
  if ( myread(fd, p_data, sizeof(float)) != sizeof(float) ) {
    fprintf(stderr, "file read error\n" );
    return (FALSE);
  }
  return (TRUE);
}

/* write 64bit double to file	-----------------------------*/
int readdouble(int fd, double *p_data)
{
  if ( myread(fd, p_data, sizeof(double)) != sizeof(double) ) {
    fprintf(stderr, "file read error\n" );
    return (FALSE);
  }
  return (TRUE);
}
/* End of File	**************************************************************/
